# 青空文庫から持ってきた文章のword2vecによるモデルを作るスクリプト

import zipfile
import os.path, urllib.request as req
import re
from janome.tokenizer import Tokenizer
from gensim.models import word2vec
from wordcloud import WordCloud

url = "https://www.aozora.gr.jp/cards/000119/files/624_ruby_5668.zip" #山月記
#url = "https://www.aozora.gr.jp/cards/000148/files/773_ruby_5968.zip" #こころ
#url = "https://www.aozora.gr.jp/cards/000074/files/424_ruby_19825.zip" #檸檬
local = url.split('/')[-1]
if not os.path.exists(local):
    req.urlretrieve(url, local)

zip = zipfile.ZipFile(local, 'r')
for filename in zip.namelist():
    if filename.split('.')[-1] != 'txt' : continue
    outfile = filename.split('.')[0] + '.model'
    txt = zip.open(filename, 'r').read().decode('cp932')
zip.close()

txt = re.split(r'\-{5,}', txt)[2]
txt = re.split(r'\r\n底本', txt)[0]
txt = txt.strip()
txt = txt.replace('｜','')
txt = re.sub(r'《.+?》','', txt)
txt = re.sub(r'［＃.+?］','', txt)

t = Tokenizer()
results = []
lines = txt.split('\r\n')
for line in lines:
    tokens = t.tokenize(line)
    r = []
    for token in tokens:
        w = token.base_form             # 基本形を拾う
        if w == '*': w = token.surface
        ps = token.part_of_speech       # 品詞
        if w == "Ｋ": ps = '名詞'
        if ps.split(',')[0] in ['名詞', '形容詞', '動詞']:
            r.append(w)
    rl = (' '.join(r)).strip()
    results.append(rl)

wakachi_file = 'wakachi.txt'
with open(wakachi_file, 'w', encoding='utf-8') as f:
    f.write("\n".join(results))

data = word2vec.LineSentence(wakachi_file)
model = word2vec.Word2Vec(data, vector_size = 200, window = 10, hs = 1, min_count = 2, sg = 1)
model.save(outfile)

